/*
 * 商品评价
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ProductCommentController : BaseController
    {
        public ProductCommentController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 商品评价列表

        /// <summary>
        /// 根据条件查询商品评价列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(ProductComment data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            string Condition = "";

            if (!string.IsNullOrEmpty(Condition))
            {
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询商品评价列表

        /// <summary>
        /// 商品评价列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(ProductComment data, int page = 1, int limit = 30)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3");

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ProductComment", Fields, "Id desc", "False", page, limit);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                int UserId = int.Parse(dic["UserId"].ToString());
                int ProductId = int.Parse(dic["ProductId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                Products product = db.Products.FirstOrDefault(m => m.Id == ProductId) ?? new Products();
                dic.Add("NickName", user.NickName);
                dic.Add("ProductName", product.ProductName);
            }
            return Json(obj);
        }

        #endregion

        #region 增加商品评价

        /// <summary>
        /// 增加或修改商品评价信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 增加商品评价

        /// <summary>
        /// 增加或修改商品评价信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(ProductComment data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("Contents", data.Contents); //评论内容
            Fields.Add("StarNum", data.StarNum); //商品评分
            Fields.Add("AgreeCount", data.AgreeCount); //点赞数
            Fields.Add("BackCount", data.BackCount); //回复数
            Fields.Add("HasPhoto", data.HasPhoto); //是否有图
            Fields.Add("PhotoList", data.PhotoList); //图集

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("ProductComment", Fields, 0);
            AddSysLog(data.Id.ToString(), "ProductComment", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改商品评价

        /// <summary>
        /// 增加或修改商品评价信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            ProductComment editData = db.ProductComment.FirstOrDefault(m => m.Id == Id) ?? new ProductComment();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商品评价

        /// <summary>
        /// 增加或修改商品评价信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(ProductComment data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("Contents", data.Contents); //评论内容
            Fields.Add("StarNum", data.StarNum); //商品评分
            Fields.Add("AgreeCount", data.AgreeCount); //点赞数
            Fields.Add("BackCount", data.BackCount); //回复数
            Fields.Add("HasPhoto", data.HasPhoto); //是否有图
            Fields.Add("PhotoList", data.PhotoList); //图集

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProductComment", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "ProductComment", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除商品评价信息

        /// <summary>
        /// 删除商品评价信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ProductComment", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Delete("ProductComment", id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ProductComment", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProductComment", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ProductComment", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProductComment", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("ProductComment", Sort, Id);

            AddSysLog(Id.ToString(), "ProductComment", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.ProductComment.Add(new ProductComment()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "ProductComment", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(ProductComment data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ProductComment", Fields, "Id desc", "False", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "ProductComment", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
